// Definicija apstraktne klase kolekcija figura (Kolekcija).

#ifndef _kolekc_h_
#define _kolekc_h_

#include "figura.h"
#include <iostream.h>
#include <stdlib.h>

class Kolekcija {
protected:
  struct Elem {                           // Elementi liste:
    Figura *fig;                          //   sadrzaj elementa,
    Elem *sled;                           //   sledeci element,
    Elem (const Figura *ff, Elem *ss=0)   //   stvaranje elementa,
      { fig = (Figura *)ff; sled = ss; }
    ~Elem () { delete fig; }              //   unistavanje elementa.
  };
  Elem *prvi, *posl;                      // Pocetak i kraj liste.
  int duz;                                // Duzina liste.
  void kopiraj (const Kolekcija &) ;      // Kopiranje liste.
  void brisi () ;                         // Brisanje liste.
public:
  Kolekcija () { prvi=posl=0; duz=0; } // Stavaranje prazne kolekcije.
  Kolekcija (const Figura &ff)         // Konverzija figure u kolekciju.
    { if ((prvi = posl = new Elem (&ff)) == 0) exit (1); }
  Kolekcija (const Kolekcija &kk)      // Konstruktor kopije.
    { kopiraj (kk); }
  virtual ~Kolekcija () { brisi (); }  // Unistavanje kolekcije.
  virtual Kolekcija & operator=(const Kolekcija &kk){ // Dodela vrednosti.
    if (this != &kk) { brisi (); kopiraj (kk); }
    return *this;
  }
  int operator+ () const { return duz; }      // Broj elemenata kolekcije.
  virtual Kolekcija & operator+= (const Figura &) =0; // Dodavanje figure.
  virtual Figura & operator-- () =0 ;         // Uzimanje tekuce figure.
  virtual Figura & operator-  () const =0 ;   // Tekuca figura.
  Figura & operator[] (int) const ;           // Odabrana figura.
  friend ostream & operator<<                 // Pisanje kolekcije.
    (ostream &, const Kolekcija &) ;
  Kolekcija & operator~ ()                    // Praznjenje kolekcije.
    { brisi (); return *this; }
  virtual const char *vrsta () const =0 ;     // Vrsta kolekcije.
  virtual Kolekcija *kopija () const =0 ;     // Kopija kolekcije.
} ;

#endif;
