// Ispitivanje klasa za kolekcije figura.

#include "red.h"
#include "stek3.h"
#include "krug2.h"
#include "kvadrat.h"
#include "trougao.h"
#include <iostream.h>

Figura *citaj () {                      // CITANJE FIGURE.
  cout << "Vrsta (o, k, t)? "; char vrsta; cin >> vrsta;
  Figura *pf = 0;
  switch (vrsta) {
    case 'o': case 'O': 
      pf = new Krug;    cout << "x, y, ro? ";      break;
    case 'k': case 'K':
      pf = new Kvadrat; cout << "x, y, a? ";       break;
    case 't': case 'T':
      pf = new Trougao; cout << "x, y, a, b, c? "; break;
  }
  if (pf) cin >> *pf;
  return pf;
}

int main (int barg, char *varg[]) {     // GLAVNI PROGRAM.
  int nred = 1, nstek = 1;              // Stvaranje praznih kolekcija.
  if (barg > 1) nred  = atoi (varg[1]);
  if (barg > 2) nstek = atoi (varg[2]);
  Kolekcija **kol = new Kolekcija * [nred + nstek];
  for (int i=0; i<nred+nstek; i++) 
    if (i<nred) kol[i] = new Red; else kol[i] = new Stek;
  int k = 0;                            // Indeks tekuce kolekcije.
  Figura *pf = 0;                       // Pokazivac na tekucu figuru.
  for (int dalje=1; dalje; ) {
    // Ispisivanje menija.
    cout << "\nMoguce operacije su:\n\n"
            "1 Biraj kolekciju i prikazi    7 Prikazi prvu figuru\n"
            "2 Prikazi kolekciju            8 Prikazi datu figuru\n"
            "3 Citaj figuru i stavi         9 Kopiraj kolekciju\n"
            "4 Stavi figuru                 0 Dodaj kolekciju\n"
            "5 Uzmi figuru i prikazi        p Prazni kolekciju\n"
            "6 Prikazi figuru               k Zavrsi sa radom\n"
            "\nUnesite svoj izbor: ";
    char izb; cin >> izb;
    switch (izb) {
      // Biranje kolekcije.
      case '1': cout << "Redni broj kolekcije? "; int kk; cin >> kk;
                if (kk<=0 && kk>nred+nstek)
                  { cout << "*** Neispravan redni broj!\n\a"; break; }
                k = kk - 1;
      // Prikazivanje sadrzaja tekuce kolekcije.
      case '2': cout << *kol[k];
                break;
      // itanje figure.
      case '3': { Figura *ppf = citaj ();
                  if (! ppf)
                    { cout << "*** Neispravna vrsta!\n\a"; break; }
                  delete pf; pf = ppf;
                }
      // Stavljanje tekuce figure u tekucu kolekciju.
      case '4': if (pf) *kol[k] += *pf->kopija ();
                  else  cout << "*** Nema figure!\n\a";
                break;
      // Uzimanje prve figure iz tekuce kolekcije.
      case '5': if (!+*kol[k])
                  { cout << "*** Kolekcija je prazna!\n\a"; break; }
                delete pf; pf = &--*kol[k];
      // Prikazivanje tekue figure.
      case '6': if (pf) cout << "  " << *pf << endl;
                  else  cout << "*** Nema figure!\n\a";
                break;
      // Prikazivanje prve figure u tekucoj kolekciji.
      case '7': if (+*kol[k]) cout << "  " << -*kol[k] << endl;
                  else cout << "*** Kolekcija je prazna!\n\a";
                break;
      // Prikazivanje odabrane figure iz tekuce kolekcije.
      case '8': cout << "Redni broj figure? "; int i; cin >> i;
                if (i>0 && i<=+*kol[k]) 
                  cout << "  " <<(*kol[k])[i] << endl;
                else cout << "*** Neispravan redni broj!\n\a";
                break;
      // Kopiranje tekuce kolekcije u odabranu kolekciju
      //   (stari sadrzaj odredisne kolekcije se unisti).
      case '9': cout << "Broj odredisne kolekcije? "; cin >> kk;
                if (kk>0 && kk<=nred+nstek) {
                  delete kol[kk-1]; kol[kk-1] = kol[k]->kopija ();
                } else cout << "*** Neispravan redni broj!\n\a";
                break;
      // Dodavanje svih figura iz tekuce kolekcije u odabranu kolekciju
      //   (stari sadrzaj odredisne kolekcije se sacuva).
      case '0': cout << "Broj odredisne kolekcije? "; cin >> kk;
                if (kk>0 && kk<=nred+nstek) { kk--;
                  for (i=1; i<=+*kol[k]; *kol[kk]+=(*kol[k])[i++]);
                } else
                  cout << "*** Neispravan redni broj!\n\a";
                break;
      // Praznjenje tekuce kolekcije.
      case 'p': case 'P': ~*kol[k]; break;
      // Zavrsetak rada.
      case 'k': case 'K': dalje = 0; break;
      // Poruka o neispravnom izboru.
      default : cout << "*** Neispravan izbor!\n\a";
    }
  }
  return 0;
}
