// Definicije funkcija uz klasu Vekt.

#include "vekt.h"

void Vekt::pravi (int poc, int kra) {        // Stvaranje vektora.
  if ((min=poc) > (max=kra))                   throw OPSEG;
  if ((niz = new double [duz=kra-poc+1]) == 0) throw MEMORIJA;
  for (int i=0; i<duz; niz[i++]=0) ;
}

void Vekt::kopiraj (const Vekt v) {          // Kopiranje vektora.
  if (! v.niz) throw PRAZAN;
  if ((niz = new double [duz=(max=v.max)-(min=v.min)+1]) == 0)
               throw MEMORIJA;
  for (int i=0; i<duz; i++) niz[i] = v.niz[i];
}

void Vekt::brisi () {delete [] niz; niz = 0;}// Unistavanje vektora.

Vekt & Vekt::operator= (const Vekt &v) {     // Dodela vrednosti.
  if (&v != this) { brisi (); kopiraj (v); }
  return *this;
}

double & Vekt::operator[] (int ind) const {  // Pristup komponenti.
  if (! niz)              throw PRAZAN;
  if (ind<min || ind>max) throw INDEKS;
  return niz[ind-min];
}

double operator* (const Vekt &v, const Vekt &w) { // Skalarni proizvod.
  if (! v.niz || ! w.niz) throw Vekt::PRAZAN;
  if (v.duz != w.duz)     throw Vekt::DUZINA;
  double s = 0;
  for (int i=0; i<v.duz; i++) s += v.niz[i] * w.niz[i];
  return s;
}
